## keepassxc 2.3.4

=== debian/changelog ===
keepassxc (2.3.4-0.1~mx17+1) mx; urgency=medium

  * New upstream release:
    - Show all URL schemes in entry view.
    - Disable merge when database is locked.
    - Fix intermittent crashes with favorite icon downloads.
    - Provide potential crash warning to Qt 5.5.x users.
    - Disable apply button when creating new entry/group to prevent data loss.
    - Allow for 12 hour timeout to lock idle database.
    - Multiple SSH Agent fixes.
    - Multiple Browser Integration enhancements.
    - Fix browser proxy application not closing properly.
    - Add real names and Patreon supporters to about dialog.
    - Add settings button to toolbar, Donate button, and Report a Bug button to
      help menu.
    - Enhancements to release-tool to appsign intermediate build products.

  * Disable automatic dbgsym packages.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 24 Aug 2018 11:40:16 -0700

keepassxc (2.3.3-0.1~mx17+1) mx; urgency=medium

  * New upstream release:
    - Fix crash when browser integration is enabled [#1923]
    - Enable high entropy ASLR on Windows [#1747]
    - Enhance favicon fetching [#1786]
    - Fix crash on Windows due to autotype [#1691]
    - Fix dark tray icon changing all icons [#1680]
    - Fix --pw-stdin not using getPassword function [#1686]
    - Fix placeholders being resolved in notes [#1907]
    - Enable auto-type start delay to be configurable [#1908]
    - Browser: Fix native messaging reply size [#1719]
    - Browser: Increase maximum buffer size [#1720]
    - Browser: Enhance usability and functionality [#1810, #1822, #1830,
      #1884, #1906]
    - SSH Agent: Parse aes-256-cbc/ctr keys [#1682]
    - SSH Agent: Enhance usability and functionality [#1677, #1679,
      #1681, #1787]

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 11 Jun 2018 11:48:36 -0700

keepassxc (2.3.1+dfsg.1-1~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 13 Mar 2018 11:08:53 -0700
