=== debian/rules ===
--- 
+++ 
@@ -22,3 +22,6 @@
 override_dh_makeshlibs:
 	# keepassx only ships plugins
 	dh_makeshlibs -X/usr/lib/$(DEB_HOST_MULTIARCH)/keepassxc
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
